import { Modal, ModalService } from '@zeedhi/common';
import { IDictionary } from '@zeedhi/core';
import { Socket } from 'socket.io-client';

export class UpdatesController {
  public socket?: Socket;

  public title: any;

  public visibleCondition({ row }: IDictionary) {
    if (row.v === '-' || row.v <= '0.0.1') {
      return false;
    }
    return true;
  }

  public visibleConditionUpdate({ row }: IDictionary) {
    let up = false;
    if (row.v === '-' || row.vd.length === 0) {
      up = false;
    } else {
      up = true;
    }
    return up;
  }

  public visibleConditionDowngrade({ row }: IDictionary) {
    if (row.v === '-' || row.v <= '0.0.1') {
      return false;
    }
    return true;
  }

  public visibleConditionStatus({ row }: IDictionary) {
    let cor;

    [row].forEach((element:any) => {
      if (element.v === '-' || element.vd !== '') {
        cor = 'red';
      } else {
        cor = 'green';
      }
    });

    return cor;
  }

  // public startModal() {
  //   Loader.getInstance('HistoricoController').createFullscreenModal();
  // }

  private fullscreenModal!: Modal;

  public async createFullscreenModal() {
    this.fullscreenModal = await ModalService.createFromJson('historico', true);
  }

  public destroyFullscreenModal() {
    this.fullscreenModal?.destroy();
  }

  public openFullscreenModal() {
    this.fullscreenModal.show();
  }

  public closeFullscreenModal() {
    this.fullscreenModal.hide();
  }

  /**
   * Método executado quando o grid é criado
   */
  public gridMounted() {
    // inicializa o socket
    // this.socket = io(Config.endPoint);

    // this.socket.off(SocketEvent.CONNECTION)
    //   .emit('salesDelivery', {
    //     slave: false,
    //   });

    // this.socket.off(SocketEvent.CONNECTION)
    //   .on('salesDelivery', async (branc: IDictionary) => {
    //     await component.datasource.updateData(branc.message.vendas);
    //     await component.datasource.get();
    //   });
  }

  public selectClick({ component }: any) {
    const itemsText = component.selectedRows.map((item: any) => item.id).join(', ');
    component.getChildInstance('selected-rows').text = `selectedRows = [${itemsText}]`;
  }

  /**
   * Método executado logo antes do grid ser destruído
   */
  public gridBeforeDestroy() {

  }
}
